



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>tomcat部署应用的几种方式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">tomcat部署应用的几种方式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 10:02:14 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>接着上篇 <a href="http://www.cnblogs.com/yhzh/p/5364630.html" rel="external nofollow noreferrer">tomcat配置详解</a>，再来学习下如何在tomcat下部署应用</p>
<p>1.部署方式</p>
<p>第一种，最常用，直接把WAR包或者文件夹直接放到webapps目录下面，这时访问路径就是WAR包或者文件夹的名称。</p>
<p>如果想要context为空，即以http://localhost:8080/ 形式访问，只要将WAR包重命名为ROOT.WAR或者将文件夹重命名为ROOT</p>
<p>ps:webapps其实是Host节点appBase属性的值，相对路径是相对于$CATALINA_BASE的，即$CATALINA_BASE/webapps，也可以配置为其他的值，或者一个绝对路径，这样那个目录下的WAR包或者文件夹都会在Tomcat启动时被自动发布</p>
<p>第二种， 在host节点下增加一个Context节点，一个Host节点可以包含多个Context节点。</p>
<p><code>&lt;Context&nbsp;path="/test"&nbsp;docBase="test"<strong>/&gt;</strong></code>其中path就是Context，如果要配置根目录，只有设置path=&rdquo;&rdquo;；docBase就是文件夹名称或者是WAR包名，如果是相对路径，则是相对于它所在Host节点的appBase</p>
<p>ps:不要将docBase指向webapps下的某个WAR或者文件夹，这样可能会导致应用被多次发布;这种方式发布应用，需要重启Tomcat才能生效</p>
<p>我修改了默认的server.xml,</p>
<div>
<pre class="prettyprint linenums">&lt;Host name="localhost"  appBase="myapps"<br />
            unpackWARs="false" autoDeploy="true"<br />
            xmlValidation="false" xmlNamespaceAware="false"&gt;<br />
　　&lt;Context path="/test" docBase="assetmgmt"/&gt;<br />
&lt;/Host&gt;</pre>
</div>
<p>发现http://127.0.0.1:8080/assetmgmt/或http://127.0.0.1:8080/test/ 都能访问，出现这种情况是由于assetmgmt.war放在了myapps下导致项目被重复部署</p>
<p>第三种，在conf\Catalina\localhost下面添加test.xml，</p>
<div>
<p>&lt;?xml version="1.0" encoding="UTF-8"?&gt;</p>
<p>&lt;Context&nbsp;path=""&nbsp;docBase="C:\Users\du\Desktop\to\apache-tomcat-6.0.43_manage\assetmgmt.war" &gt;</p>
<p>&lt;/Context&gt;</p>
</div>
<p>这样就能通过http://127.0.0.1:8080/test/ 访问了</p>
<p>这种方式其实是在$CATALINA_BASE/conf/{enginename}/{hostname}，默认是$CATALINA_BASE/conf/Catalina/localhost下面添加一个{context}.xml，这样就使用这个xml的文件名作为项目path：http://127.0.0.1:8080/{context}/访问，如果{context}有多层，则用#间隔，例如a#b#c.xml，就用http://127.0.0.1:8080/a/b/c/访问</p>
<p>ps:path不用指定，同样也不能把war包放在{hostname}的{appBase}下，不用重启Tomcat部署就能生效</p>
<p>第四种，直接登录tomcat&nbsp;管理控制台：http://localhost:8080/，使用tomcat manager发布</p>
<p>2.其它部署配置</p>
<p>1.如果想只启动一个tomcat,使用不同端口提供服务，只要增加Service节点并相应改动相关值，</p>
<div>
<pre class="prettyprint linenums">&lt;Service name="Catalina1"&gt;<br />
　　&lt;Connector connectionTimeout="20000" port="" protocol="HTTP/1.1" redirectPort="8443"/&gt;<br />
　　&lt;Engine defaultHost="localhost" name="Catalina1"&gt;<br />
　　　　&lt;Host appBase="webapps" autoDeploy="true" name="localhost" unpackWARs="true" xmlNamespaceAware="false" xmlValidation="false"&gt;<br />
　　　　　　&lt;Context path="/test" docBase="test"/&gt;<br />
　　　　&lt;/Host&gt;<br />
　　&lt;/Engine&gt;<br />
&lt;/Service&gt;</pre>
</div>
<p>2.如果一个站点配置多个应用，可以同过增加host虚拟主机的方式实现</p>
<div>
<pre class="prettyprint linenums">&lt;Host appBase="aaa" autoDeploy="true" name="www.aaa.com" unpackWARs="true"<br />
xmlNamespaceAware="false" xmlValidation="false"&gt;<br />
&lt;Context path="/test" docBase="test"/&gt;<br />
&lt;/Host&gt;

&lt;Host appBase="bbb" autoDeploy="true" name="www.bbb.com" unpackWARs="true"<br />
xmlNamespaceAware="false" xmlValidation="false"&gt;<br />
&lt;Context path="/test" docBase="test"/&gt;<br />
&lt;/Host&gt;</pre>
</div>
<p>这样www.aaa.com:8080/test的访问实际是访问$CATALINA_BASE/aaa/test的访问，而对www.bbb.com:8080/test的访问实际是对$CATALINA_BASE/bbb/test的访问</p>
<p>参考文章：</p>
<p>1.<a href="http://blog.csdn.net/sdd00001/article/details/16844203" rel="external nofollow noreferrer">Tomcat6上部署应用配置详解</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qy6nlx8.html">Java-BlockingQueue的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvom5x8.html">vm10&period;0key</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1v7v19.html">Regex   字符是不是汉字</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxneyx08.html">mysql开启general log的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vp67o8.html">&lbrack;Codeforces677C&rsqb;Vanya and Label（组合数学，快速幂）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xdll68.html">微软IIS服务器的最佳优化工具- IIS Tuner</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj76k49.html">H5 适配 动画animation js touch</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1gw6j9.html">iOS音频处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1o06k8.html">ADB命令与monkey</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojkowlq.html">《转》Linux下的多线程编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j27zw8.html">&period;net core web api &plus; Autofac &plus; EFCore 个人实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojlye1q.html">工具：Entity Framework Profiler</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgwvy78.html">Android WebView默认GONE出现的问题记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgl0xm8.html">天梯赛-L1-018&period; 大笨钟</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk761v8.html">mysql使用错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k12459.html">Android- APP 秒开</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zodvnxq.html">RestTemplate的逆袭之路，从发送请求到负载均衡</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdeg5z9.html">BootStrap标题制作模板</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwgdz48.html">【CF434D】Nanami&amp;&num;39&semi;s Power Plant 最小割</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjljjl9.html">原生js的dom操作</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1z4dv69.html">HDU 4919 Exclusive or （数论 or 打表找规律）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvk7loq.html">jpa仓库接口</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmvxz09.html">AutoCAD&period;NET二次开发：创建自定义菜单（COM）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w3vmwq.html">Quality Center11初始化失败</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvkoj1q.html">Hibernate HQL和原生SQL查询的一点区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xdvne8.html">UI进阶 数据加密</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mdv3jq.html">ABA problem</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmv0we9.html">python求3的倍数与和</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvkw4jq.html">linux 查看当前路径命令：pwd</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvky0xq.html">java笔记-关于一些常用 且实用的开源包</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
